//	Re_Corner.js
//	http://www.pictrix.jp/	Umezawa
//


if (documents.length > 0 && activeDocument.pathItems.length > 0){


	SelObj = activeDocument.selection[ 0 ];
	SelPts = SelObj.pathPoints.length;

ap = new Array();
p1 = new Array();
p2 = new Array();
p3 = new Array();
p4 = new Array();
pos = new Array();

	sted = 0;
	count = 0;

	for ( i = 0; i < SelPts; i++ ){

		if ( SelObj.pathPoints[ i ].selected == PathPointSelection.ANCHORPOINT ){

			if ( i == 0 || i == SelPts - 1 ) sted++;
			ap[ count++ ] = i;
		}
	}

	if ( count < 2 ) alert( "Select error" );

	else {

		last = count - 1;

		if ( SelObj.closed && sted == 2 ){

			i = 0;
			while ( i < last ){
				if ( ap[ i + 1 ] != ap[ i ] + 1 ){
					ap2 = ap[ i ];
					ap1 = ap2 + 1;
					break;
				}
				i++;
			}

			i = last;
			while ( i >= 0 ){
				if ( ap[ i - 1 ] != ap[ i ] - 1 ){
					ap3 = ap[ i ];
					ap4 = ap3 - 1;
					break;
				}
				i--;
			}

			for ( i = 0; i < last; i++ ){
				for ( j = i + 1; j <= last; j++ ){
					if ( ap[ i ] > ap[ j ] ){
						wk = ap[ i ];
						ap[ i ] = ap[ j ];
						ap[ j ] = wk;
					}
				}
			}

		}
		else{

			ap2 = ap[ 0 ];
			ap3 = ap[ last ];
			ap1 = ( ap2 == 0 )? SelPts - 1 : ap2 - 1;
			ap4 = ( ap3 == SelPts - 1 )? 0 : ap3 + 1;
		}

		p2 = SelObj.pathPoints[ ap2 ].anchor;
		p3 = SelObj.pathPoints[ ap3 ].anchor;
		p1 = SelObj.pathPoints[ ap1 ].anchor;
		p4 = SelObj.pathPoints[ ap4 ].anchor;

		err = inter( pos, p3, p4, p1, p2 );
		if ( err )
			alert( "error" );

		else{

			newpt = SelObj.pathPoints[ ap2 ];
			newpt.anchor			= pos;
			newpt.leftDirection	= pos;
			newpt.rightDirection	= pos;

			for ( i = last; i >= 0; i-- ){
				if ( ap[ i ] != ap2 ) SelObj.pathPoints[ ap[ i ] ].remove();
			}
		}
	}
}


function inter( ret, p3,p4, p1, p2 )
{
	var v1 = new Array;
	var v2 = new Array;
	var d1, d2, wk;

	VNORM3( v1, p2, p1 );
	VNORM3( v2, p4, p3 );

	wk = v2[ 0 ];
	v2[ 0 ] = v2[ 1 ];
	v2[ 1 ] = wk;
	if ( v2[ 0 ] ) v2[ 0 ] = -v2[ 0 ];
	else		     v2[ 1 ] = -v2[ 1 ];

	d1 = v2[ 0 ] * ( p1[ 0 ] - p3 [ 0 ] ) + v2[ 1 ] * ( p1[ 1 ] - p3[ 1 ] );
	d2 = v1[ 0 ] * v2[ 0 ] + v1[ 1 ] * v2[ 1 ];

	if ( d2 > -0.009 && d2 < 0.009 ){
		return -1;
	}
	else{

		ret[ 0 ] = p1[ 0 ] - v1[ 0 ] * ( d1 / d2 );
		ret[ 1 ] = p1[ 1 ] - v1[ 1 ] * ( d1 / d2 );
		return 0;
	}
}


function VNORM3( v3, v1, v2 )
{
	VSUB3( v3, v1, v2 );
	VDIV( v3, VLEN( v3 ) );
}

function VDIV( v1, s )
{
	v1[ 0 ] /= s;
	v1[ 1 ] /= s;
}

function VSUB3( v3, v1, v2 )
{
	v3[ 0 ] = v1[ 0 ] - v2[ 0 ];
	v3[ 1 ] = v1[ 1 ] - v2[ 1 ];
}

function VLEN( v )
{
	return ( Math.sqrt( v[ 0 ] * v[ 0 ] + v[ 1 ] * v[ 1 ] ) );
}














